
#include <pthread.h>
#include <alsa/asoundlib.h>

/*SAPAudio header, for ALSA ************************************************/

class SAPAudio {
	public:
		/*Sampling rate*/
		unsigned sampleRate;
		/*Any sap tune opened*/
		unsigned char anyOpened;
		/*Is playing*/
		unsigned char isPlaying;
		/*Current song*/
		int currentSong;
		/*Maximum song*/
		int maximumSong;
		/*Pause status*/
		unsigned char paused;
		/*STOP status*/
		unsigned char stopped;
	
		/*Open a SAP tune, returns -1 when failed*/
		int openSAP(char* filespec);
		/*Close SAP*/
		void closeSAP();
	
		/*Play SAP*/
		void playSAP();
		/*Stop SAP*/
		void stopSAP();
		/*Pause SAP*/
		void pauseSAP();
		/*Next subsong*/
		void nextSubsong();
		/*Previous subsong*/
		void previousSubsong();
	
		/*Error handling*/
		char* getLastError();
	
		/*SDL Audio*/
		void initAudio();
		void destroyAudio();
		
		/*Display current/max song*/
		char songChr[8];
		
		/*Update the current/max song string*/
		void updateSongChr();

		/*ALSA*/
		snd_pcm_t *playback_handle;	//Playback handle
		snd_pcm_stream_t stream;

		/*Is this paused?*/
		int getPaused();

		/*Repeat only one subsong*/
		int oneRepeat;
};
