/***************************************************************************
 *   Copyright (C) 2006 by Michael Kalouš   *
 *   zylon@post.cz   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*Audio playing routines*/
class SAPAudio {
	public:
		/*Sampling rate*/
		unsigned sampleRate;
		/*Any sap tune opened*/
		unsigned char anyOpened;
		/*Is playing*/
		unsigned char isPlaying;
		/*Current song*/
		int currentSong;
		/*Maximum song*/
		int maximumSong;
		/*Pause status*/
		unsigned char paused;
		/*STOP status*/
		unsigned char stopped;
	
		/*Open a SAP tune, returns -1 when failed*/
		int openSAP(char* filespec);
		/*Close SAP*/
		void closeSAP();
	
		/*Play SAP*/
		void playSAP();
		/*Stop SAP*/
		void stopSAP();
		/*Pause SAP*/
		void pauseSAP();
		/*Next subsong*/
		void nextSubsong();
		/*Previous subsong*/
		void previousSubsong();
	
		/*Error handling*/
		char* getLastError();
	
		/*SDL Audio*/
		void initAudio();
		void destroyAudio();
		
		/*Display current/max song*/
		char songChr[8];
		
		/*Update the current/max song string*/
		void updateSongChr();

		/*ALSA*/
		snd_pcm_t *playback_handle;	//Playback handle
		snd_pcm_stream_t stream;

		/*Is this paused?*/
		int getPaused();

		/*Repeat only one subsong*/
		int oneRepeat;
	
	
};
